<?php

namespace App\Http\Controllers;

use DB;
use Log;
use App\Users;
use Illuminate\Http\Request;
use App\Http\ResponseHelper;
use App\Jobs\WebhookJob;
use Config;

class CustomerController extends Controller
{

    private $helper;
    private $shopifyProductDao;
    private $sharedSecret;
    private $randomString;

    public function __construct()
    {
        $this->helper = new ResponseHelper();
    }

    function processWebhook()
    {       
        $this->sharedSecret  = Config::get('shopify.secret');
        // $this->webhookContent    = $this->webhook($this->sharedSecret);
        // print_r($this->webhookContent);die;
        
        $this->webhookContent = '{"id":2314247241785,"email":"dsfgh@dryh.com","accepts_marketing":true,"created_at":null,"updated_at":null,"first_name":"Bob","last_name":"Biller","orders_count":0,"state":"disabled","total_spent":"0.00","last_order_id":null,"note":"This customer loves ice cream","verified_email":true,"multipass_identifier":null,"tax_exempt":false,"phone":null,"tags":"","last_order_name":null,"currency":"CAD","addresses":[],"accepts_marketing_updated_at":null,"marketing_opt_in_level":null,"admin_graphql_api_id":"gid:\/\/shopify\/Customer\/706405506930370084"}';
        $this->randomString = $this->generateRandomString(16);
        dispatch(new WebhookJob($this->webhookContent, $this->randomString)); 

        return true;
        
    }

    function webhook($my_shared_secret){
        
        define('SHOPIFY_APP_SECRET', 'my_shared_secret');
        $hmac_header = $_SERVER['HTTP_X_SHOPIFY_HMAC_SHA256'];
        $data        = file_get_contents('php://input');
        $verified    = $this->verify_webhook($data, $hmac_header);
        error_log('Webhook verified: '.var_export($verified, true));
        return $data;

    }

    function verify_webhook($data, $hmac_header){

        $calculated_hmac = base64_encode(hash_hmac('sha256', $data, SHOPIFY_APP_SECRET, true));
        return ($hmac_header==$calculated_hmac);

    }

    function generateRandomString($length) {
        $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $charactersLength = strlen($characters);
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }
        return $randomString;
    }
    

    

}
