<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => ['cors']], function () {

    Route::post('/quiz/storeQuizResponse', 'QuizController@storeQuiz');
    Route::delete('/quiz/deleteQuiz', 'QuizController@deleteQuiz');
    Route::get('/quiz/getQuizzes', 'QuizController@getQuizzes');
    Route::get('/quiz/getQuizDetails', 'QuizController@getQuizDetails');
    Route::get('/quiz/setCustomerDetails', 'CustomerController@processWebhook');

    Route::any('{url?}/{sub_url?}', function() {

        $urlList = [
            '/quiz/startQuiz',
            '/quiz/storeQuizAnswer',
            '/quiz/deleteQuiz',
            '/quiz/getQuizzes',
            '/quiz/getQuizDetails'
        ];

        $domain = substr(Request::root(), 0);

        $url = Request::url();

        $urlPath = str_replace($domain, "", $url);

        if (in_array($urlPath, $urlList)) {
            return response()->json([
                'status'  => 600,
                'message' => 'error',
                'body'    => [
                    'error' => 'Malformed Request'
                ]
            ]);
        } else {
            return response()->json([
                'status'  => 404,
                'message' => 'error',
                'body'    => [
                    'error' => 'Route not found'
                ]
            ]);
        }

    });

    Route::fallback(function() {

        return response()->json([
            'status'  => 404,
            'message' => 'error',
            'body'    => [
                'error' => 'Route not found'
            ]
        ]);
    });
});